"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const BaseTransformer_1 = __importDefault(require("./BaseTransformer"));
const util_1 = require("../util");
class PaginationTransformer extends BaseTransformer_1.default {
    static fetch(meta) {
        if (!meta) {
            meta = Object.assign({}, meta, { pagination: {}, include: [] });
        }
        if (!(0, util_1.hasOwnProperty)(meta, 'pagination')) {
            return super.fetch(meta, true);
        }
        const { pagination, include } = meta;
        const payload = Object.assign({}, pagination, {
            perPage: pagination.per_page,
            totalPages: pagination.total_pages,
            currentPage: pagination.current_page || 1,
            total: pagination.total,
            links: pagination.links,
            count: pagination.count || 0,
            page: pagination.current_page,
            itemsPerPage: pagination.per_page,
            pageCount: pagination.total_pages,
            itemsLength: pagination.total,
            pageStart: 0,
            pageStop: pagination.count,
            include,
        });
        return super.fetch(payload, true);
    }
}
exports.default = PaginationTransformer;
